#!/bin/sh

#V3.24.50.187
#drwxrwxr-x au/au             0 2020-02-27 11:20 ./
#drwxrwxr-x au/au             0 2020-02-27 11:20 ./usr/
#drwxrwxr-x au/au             0 2020-02-27 11:20 ./usr/bin/
#-rwxrwxrwx au/au             0 2020-02-27 11:05 ./usr/bin/cbup.sh
#drwxrwxr-x au/au             0 2020-02-27 11:20 ./tmp/
#drwxrwxr-x au/au             0 2020-02-27 11:20 ./tmp/cbuptmp/
#-rwxrwxr-x au/au        768572 2020-02-27 11:24 ./tmp/cbuptmp/mqtt-gw
#-rwxrwxr-x au/au         72427 2020-02-27 11:24 ./tmp/cbuptmp/chenbei.lua
#-rwxrwxr-x au/au         37996 2020-02-27 11:24 ./tmp/cbuptmp/tcpcfg.lua
#-rw-rw-r-- au/au         11571 2020-02-27 11:24 ./tmp/cbuptmp/netmge.sh
#-rwxr-x--x au/au          2092 2020-02-27 11:24 ./tmp/cbuptmp/BTN_1.chenbei
#-rwxr-x--x au/au         11171 2020-02-27 11:24 ./tmp/cbuptmp/json.lua

if [ ! -e /tmp/cbuptmp ]; then
	return -1
fi

[ -e /tmp/cbuptmp/y.tar.gz ] && {
	tar zxvf /tmp/cbuptmp/y.tar.gz -C /
	rm -rf /tmp/luci*;
	/etc/init.d/netmge stop;
	/etc/init.d/netmge start;
	exit 0
}

#[ -e /tmp/cbuptmp/remote_back.sh ] && {
[ -e /tmp/cbuptmp/remote_back.tar.gz ] && {
	tar zxvf /tmp/cbuptmp/remote_back.tar.gz -C /
	/etc/init.d/remotebackd start
	rm -rf /tmp/cbuptmp/
	sleep 5
	/etc/init.d/remotebackd stop

	#cp /etc/init.d/appmged /etc/init.d/appmgedd
	#/etc/init.d/appmgedd enable
	#/etc/init.d/appmgedd start
	exit 0
}

[ -e /tmp/cbuptmp/fw.bin ] && {
	sysupgrade -F /tmp/cbuptmp/fw.bin
	exit 0
}

[ -e /tmp/cbuptmp/mqtt-gw ] && {
	cp /tmp/cbuptmp/mqtt-gw /usr/bin/ -rf
}
[ -e /tmp/cbuptmp/libpaho-mqtt3as.so.1 ] && {
	cp /tmp/cbuptmp/libpaho-mqtt3as.so.1 /usr/lib/ -rf
}

[ -e /tmp/cbuptmp/gpio ] && {
	cp /tmp/cbuptmp/gpio /usr/bin/ -rf;
	chmod a+x /usr/bin/gpio
}

[ -e /tmp/cbuptmp/boot ] && {
	cp /tmp/cbuptmp/boot /etc/init.d/ -rf
	chmod a+x /etc/init.d/boot
}

[ -e /tmp/cbuptmp/AmberGwZ3 ] && {
	/etc/init.d/amber stop 2>/dev/null
	sleep 1 
	cp /tmp/cbuptmp/AmberGwZ3 /usr/bin/ -rf
	chmod 777 /usr/bin/AmberGwZ3

	/etc/init.d/amber start 2>/dev/null
}

[ -e /tmp/cbuptmp/BTN_1.chenbei ] && { 
	cp /tmp/cbuptmp/BTN_1.chenbei /etc/rc.button/BTN_1 -rf
}

[ -e /tmp/cbuptmp/tcpcfg.lua ] && { 
	cp /tmp/cbuptmp/tcpcfg.lua /etc/config/dusun/mqtt-gw/ -rf
}
[ -e /tmp/cbuptmp/chenbei.lua ] && { 
	cp /tmp/cbuptmp/chenbei.lua /etc/config/dusun/mqtt-gw/ -rf
}

[ -e /tmp/cbuptmp/mqtt-gw.config ] && { 
	#cp /tmp/cbuptmp/mqtt-gw.config /etc/config/mqtt-gw -rf
	mac=`cat /sys/class/net/eth0/address | awk '{printf "%s",$1}'`
	clientid=`echo DusunGateway_$mac | md5sum | awk '{printf "%s",$1}'`
	uci set /etc/config/mqtt-gw.server.clientid=ds${clientid}
	uci set /etc/config/mqtt-gw.server.username=$mac
	uci set /etc/config/mqtt-gw.server.password=$mac
	uci set /etc/config/mqtt-gw.server.heartbeat=20
	uci commit /etc/config/mqtt-gw
}

[ -e /tmp/cbuptmp/json.lua ] && { 
	cp /tmp/cbuptmp/json.lua /usr/lib/lua/luci -rf
}

[ -e /tmp/cbuptmp/netmge ] && { 
	/etc/init.d/netmged stop 2>/dev/null
	sleep 1 
	cp /tmp/cbuptmp/netmge /usr/bin/ -rf
	chmod 777 /usr/bin/netmge
	/etc/init.d/netmged start 2>/dev/null
}

[ -e /tmp/cbuptmp/ppp ] && { 
	cp /tmp/cbuptmp/ppp /etc/config/ -rf
}

[ -e /tmp/functions.sh ] && {
	cp /tmp/cbuptmp/functions.sh /lib/ -rf
}

[ -e /tmp/cbuptmp/ap_client ] && { 
	local lxx=`uci get /etc/config/network.wan1 2>/dev/null`
	#[ ! "$lxx" == "interface" ] &&  {
		uci del /etc/config/network.wan1
		uci set /etc/config/network.wan1=interface
		uci set /etc/config/network.wan1.ifname='apcli0'
		uci set /etc/config/network.wan1.force='1'
		uci set /etc/config/network.wan1.proto='none'

		uci del /etc/config/network.pwan
		uci set /etc/config/network.pwan=interface
		uci set /etc/config/network.pwan.ifname='ppp0'
		uci set /etc/config/network.pwan.force='1'
		uci set /etc/config/network.pwan.proto='3g'

		uci commit /etc/config/network
		uci commit network

		uci del_list firewall.@zone[1].network='wan1'
		uci add_list firewall.@zone[1].network='wan1'
		uci del_list firewall.@zone[1].network='pwan'
		uci add_list firewall.@zone[1].network='pwan'
		uci commit /etc/config/firewall
		uci commit firewall
	#}
	
	/etc/init.d/ap_clientd stop 2>/dev/null
	/etc/init.d/network stop 2>/dev/null
	sleep 1
	
	cp /tmp/cbuptmp/ap_client /usr/bin/ -rf
	cp /tmp/cbuptmp/ap_clientd /etc/init.d/ -rf
	chmod 777 /usr/bin/ap_client
	chmod 777 /etc/init.d/ap_clientd

	/etc/init.d/network start 2>/dev/null
	/etc/init.d/ap_clientd start 2>/dev/null
}


[ -e /tmp/cbuptmp/bt_host.exe ] && {
	/etc/init.d/bt_host stop
	sleep 1
	cp /tmp/cbuptmp/bt_host.exe /usr/bin/bt_host -rf
}

[ -e /tmp/cbuptmp/bw_moni.exe ] && {
	/etc/init.d/bw_moni stop
	sleep 1
	cp /tmp/cbuptmp/bw_moni.exe /usr/bin/bw_moni -rf
}

[ -e /tmp/cbuptmp/ucs2text ] && {
	cp /tmp/cbuptmp/ucs2text /usr/bin/ -rf
}

[ -e /tmp/cbuptmp/bt_host.sh ] && {
	cp /tmp/cbuptmp/bt_host.sh /etc/init.d/bt_host -rf
	/etc/init.d/bt_host enable
}

[ -e /tmp/cbuptmp/bw_moni.sh ] && {
	cp /tmp/cbuptmp/bw_moni.sh /etc/init.d/bw_moni -rf
}

# 升级会清空流量
[ -e /tmp/cbuptmp/firewall.user ] && {
	cp /tmp/cbuptmp/firewall.user /etc/firewall.user -rf
}

[ -e /tmp/cbuptmp/bw_moni.conf ] && {
	cp /tmp/cbuptmp/bw_moni.conf /etc/config/bw_moni -rf
	/etc/init.d/bw_moni enable
}

[ -e /tmp/cbuptmp/system ] && {
	cp /tmp/cbuptmp/system /etc/config/system -rf
}

[ -e /tmp/cbuptmp/blecfg.lua ] && {
	cp /tmp/cbuptmp/blecfg.lua /etc/config/dusun/mqtt-gw/ -rf
}

[ -e /tmp/cbuptmp/dusun_build ] && {
	cp /tmp/cbuptmp/dusun_build /etc/dusun_build -rf
}
#/etc/init.d/dropbear disable                                     
#/etc/init.d/dnsmasq disable

/etc/init.d/uhttpd disable 2>/dev/null
/etc/init.d/uhttpd stop 2>/dev/null 
/etc/init.d/device-manage disable 2>/dev/null 
/etc/init.d/device-manage stop 2>/dev/null
/etc/init.d/peripher-test disable 2>/dev/null
/etc/init.d/peripher-test stop 2>/dev/null
/etc/init.d/appmged disable 2>/dev/null
/etc/init.d/appmged stop 2>/dev/null
/etc/init.d/logicd disable 2>/dev/null
/etc/init.d/logicd stop 2>/dev/null

# 新增wifi配置优化
[ -e /tmp/cbuptmp/mt7620.dat ] && {
	cp /tmp/cbuptmp/mt7620.dat /etc/wireless/mt7620/mt7620.dat -rf
	sleep 2
	reboot
}
#/etc/init.d/appmged enable 2>/dev/null;
#/etc/init.d/appmged stop 2>/dev/null;
#/etc/init.d/appmged start 2>/dev/null;

#reboot;

rm -rf /tmp/cbuptmp

#sed -i 's/V3.*/V3.52.321.448_z4G_ChenBei_0c4993c/g' /etc/dusun_build
#cp /tmp/cbuptmp/dusun_build /etc/ -rf;

#/usr/bin/netmge.sh > /dev/null &

/etc/init.d/mqtt-gw restart
/etc/init.d/bt_host restart
/etc/init.d/bw_moni restart

return 0
